#ifndef	__DRIVER_DEF_H__
#define	__DRIVER_DEF_H__

#include "Nand\NandDef.h"

#define BCH8	// Driver Use BCH8

#define NAND_Illegal_BLK_NUM				0x08
#define MAX_BAD_BLK							0x20

//#define USB_UPDATE
typedef struct
{	
	WORD	wMainCtrl;
	WORD	wAddrCycleCtrl;	
	WORD	wReadPageBCHCtrl;
	WORD	wWritePageBCHCtrl;
		
	WORD	wBadFlgByteOfs;
	DWORD	dwBadFlgPage1;
	DWORD	dwBadFlgPage2;	
}NF_PHY_INFO;

typedef struct
{
	WORD bad_blk[MAX_BAD_BLK];
	WORD wArrayIndex;
}BAD_BLK_ARRAY;

/* ------ zurong add these Macros for Driver and User Config Interface ---- */

/////////////////// 	Physical Layer Define(s)	////////////////////////////
#define NAND_PHY_ADDR_CYCLE_CTRL			(gNandPhyInfo.wAddrCycleCtrl)
#define NAND_READ_PAGE_BCH_CTRL				(gNandPhyInfo.wReadPageBCHCtrl)
#define NAND_WRITE_PAGE_BCH_CTRL			(gNandPhyInfo.wWritePageBCHCtrl)
#define NAND_MAIN_CTRL						(gNandPhyInfo.wMainCtrl)

//------------C Area Flag Offset Define-----------------------
#define NAND_BAD_FLG_ON_PAGE1				(gNandPhyInfo.dwBadFlgPage1)
#define NAND_BAD_FLG_ON_PAGE2				(gNandPhyInfo.dwBadFlgPage2)
#define NAND_C_AREA_BAD_FLAG_OFS			(gNandPhyInfo.wBadFlgByteOfs)

#define NAND_C_AREA_BAD_FLG_OFS_1			(0x00)	// 1 byte
#define NAND_C_AREA_COUNT_OFS				(0x01)  // 1 byte
#define NAND_C_AREA_LOGIC_BLK_NUM_OFS		(0x02)	// 2 byte
#define NAND_C_AREA_EXCHANGE_BLK_TYPE_OFS	(0x04)	// 1 byte
#define NAND_C_AREA_BAD_FLG_OFS_6			(0x05)	// 1 byte
#define NAND_C_AREA_PAGE_TO_PAGE_OFS		(0x06)	// 2 byte
//-----------------------------------------------------

///////////////////		Manage Layer Define(s)		///////////////////////////
#define SECTOR_SIZE_SHIFT					0x09
#define NAND_CHIP_ID						(pNandUserInfo->ulSelectID)
#define	NAND_TYPE							(pNandUserInfo->uiNandType)
#define NAND_MM_NUM							(pNandUserInfo->uiMM_Num)				//  DriverʹüMM
#define NAND_BLK_NUM						(pNandUserInfo->uiBlkNum)				//	Nandжٸblock
#define NAND_BANK_NUM						(pNandUserInfo->uiBankNum)				//	NandֶٸBank
#define NAND_BANK_SIZE						(pNandUserInfo->uiBankSize)				//	ÿBankжٸlogical block
#define NAND_BANK_RECYCLE_SIZE				(pNandUserInfo->uiBankRecSize)			//	ÿBankжٸ block
#define NAND_BLOCK_PAGE_SIZE				(pNandUserInfo->uiPageNum)				//	ÿBlockжٸPage
#define NAND_PAGE_SIZE						(pNandUserInfo->uiPageSize)				// 	ÿpageжٸbyte
#define NAND_PAGE_SPARE_SIZE				(pNandUserInfo->uiPageSpareSize)
#define NAND_APP_AREA_START					(pNandUserInfo->uiAppStart)
#define NAND_APP_AREA_SIZE					(pNandUserInfo->uiAppSize)
#define NAND_APP_AREA_SPARE_START			(pNandUserInfo->uiAppSpareStart)
#define NAND_APP_AREA_SPARE_SIZE			(pNandUserInfo->uiAppSpareSize)
#define NAND_DATA_AREA_START				(pNandUserInfo->uiDataStart)

#define NAND_BOOT_AREA_WRITE_ATTR			(pNandUserInfo->uiBootAreaWriteAttr)
#define NAND_APP_AREA_WRITE_ATTR			(pNandUserInfo->uiAppAreaWriteAttr)
#define NAND_DIRECT_READ					(pNandUserInfo->uiDirReadSupport)
#define NAND_WithECCEngine					(pNandUserInfo->ucWithEccEngine)		//kingchao add, 2015/06/09

#define NAND_PAGE_SECTOR_SIZE				(NAND_PAGE_SIZE>>SECTOR_SIZE_SHIFT)	//	ÿpageжٸsector
#define NAND_BLK_SECTOR_MASK				(NAND_PAGE_SECTOR_SIZE -1)
#define NAND_BLK2SECTOR_SHIFT				(gNandBlk2SectorShift)
#define NAND_BLK2PAGE_SHIFT					(gNandBlk2PageShift)
#define NAND_PAGE2SECTOR_SHIFT				(gNandPage2SectoShift)
//#define NAND_SECTOR2WORD_SHIFT			(SECTOR_SIZE_SHIFT>>BYTE2WORD)
#define NAND_SECTOR2WORD_SHIFT				(SECTOR_SIZE_SHIFT - BYTE2WORD)        // fix shift bit bug 090219.

//--------NAND READ WRITE AREA define-----------------
#define NAND_GOOD_BLK						0xffff
#define NAND_GOOD_TAG						0xff
#define	NAND_ORG_BAD_BLK					0xff00
#define NAND_ORG_BAD_TAG					0x00	
#define	NAND_USER_BAD_BLK					0xff44
#define	NAND_USER_BAD_TAG					0x44
#define NAND_FIRST_SCAN_BAD_BLK				0xff55
#define NAND_FIRST_SCAN_BAD_TAG				0x55
#define NAND_MAPTABLE_BLK					0xff66		// word
#define NAND_MAPTABLE_TAG					0xff66		// word
#define NAND_SAVE_HEAD_BLK					0xff60
#define NAND_SAVE_HEAD_TAG					0xff60
#define NAND_START_WRITE                    0x88
#define NAND_END_WRITE                      0x99
#define NAND_EXCHANGE_A_BLK					0xffaa
#define NAND_EXCHANGE_A_TAG					0xaa
#define NAND_EXCHANGE_B_BLK					0xffbb
//#define NAND_EXCHANGE_B_TAG				0xffbb
#define NAND_EXCHANGE_B_TAG					0xbb		//modify by wwj

//-----------------------------------------------------
#define NAND_MAPTAB_UNUSE					0x7fff
#define NAND_EMPTY_BLK						0xffff
#define NAND_ALL_BIT_FULL					0xffff
#define NAND_FREE_BLK_MARK_BIT				(1<<15)

//------------- NAND define ---------------------------
#define NULL								0x00		//only flush target block
#define	NAND_BUF_FLUSH_ALL					(1<<0)		//force to flush A exchange , become all free		
#define	NAND_BUF_GET_EXCHANGE				(1<<1)		//get a block 
#define	NAND_ALL_BUF_FLUSH_ALL				(1<<2)		//get a block 
//---------------------------------------------------------
#define MAPTAB_WRITE_BACK_N_NEED			0x01
#define MAPTAB_WRITE_BACK_NEED				0x10
#define NF_READ								0x01
#define NF_WRITE							0x10

#define NF_PHY_WRITE_FAIL					0xaa
#define NF_PHY_READ_FAIL					0x55

#define NF_WORKBUFFER_BK					0x01
#define NF_WORKBUFFER						0x10

//----------------------------------------------------------
#define Nand_Control_Word_8bit  			0x0055
#define Nand_Control_Word_16bit  			0x4055

#define Channel0    						0x0001
#define Channel1    						0x0002
#define Channel2							0x0003
#define Channel3							0x0004

#define FIRST_ALL_BANK_OK					0x1000

#endif
