#include "GPL951_Body.h"
#include "NAND\NandConfig.h"
#include "NAND\DriverDeclare.h"

/*######################	Warning		############################
#																	#
#		Don`t modify the content below,otherwise it will			#
# 	be cause driver can`t work normally or can`t work optimumly!	#
#																	#
###################################################################*/
__attribute__((section("NF_MM: .section .iram " ))) 						MM 				mm[MM_NUM];
__attribute__((section("NF_TT: .section .iram " ))) 						TT 				tt;
__attribute__((section("NF_TT_BK: .section .iram " ))) 						TT 				tt_bk;
__attribute__((section("NF_TT_APP: .section .iram " ))) 					TT 				tt_APP;
__attribute__((section("NF_MM_MP3: .section .iram " ))) 					MP3_MM_TYPE 	mm_MP3;
__attribute__((section("NF_TT_MP3: .section .iram " ))) 					MP3_TT_TYPE 	tt_MP3;

__attribute__((section("NF_BANK_INFO_BK: .section .iram" ))) BANK_INFO 		gBankInfo_BK[BANK_NUM];

BANK_INFO  		gBankInfo[BANK_NUM];
WORD 			gMaptableChanged[MM_NUM];
EXCHANGE_A_BLK	gExchangeABlock[ExchangeAMaxNum];
L2P   			gL2PTable[APP_AREA_SPARE_SIZE];
//L2P   			gL2PTable[BLK_NUM - ((BLK_NUM*24ul)/25)- 1];		//Buffer must be large enough for CS3 Nand
//L2P   			gL2PTable[256];											//Buffer must be large enough for CS3 Nand

UINT	R_NF_Ctrl;						//wwj add
UINT	R_Burst_Read;					//wwj add
UINT	R_Burst_Write;					//wwj add

void	Get_Nand_Settings(void);		//wwj add


//==========================================================================================================
//wwj add for Nand ROM/OTP support
extern  unsigned int NandRomFlag;

#define	C_LOADER1_SIZE		(20ul*1024)
#define	C_LOADER1_SECTORS	(C_LOADER1_SIZE/512)

#define C_LOADER2_SIZE		(64ul*1024)
#define	C_LOADER2_SECTORS	(C_LOADER2_SIZE/512)

DWORD	R_BootLoader_Sectors;			//wwj add, 2009/10/26
//==========================================================================================================


const WORD NAND_ID_Table[][2] =
{
	{0x73,  16  },    //16MB
	{0x74,  16  },    //16MB
	{0x34,  16  },    //16MB
	{0x75,  32  },	  //32MB
	{0x35,  32  },	  //32MB
	{0x78,  128 },	  //128MB	//wwj add, 2010/3/26
	{0x76,  64  },    //64MB
	{0x36,  64  },    //64MB
	{0xF1,  128 },    //128MB
	{0xD1,  128 },    //128MB   //wwj add
	{0xDA,  256 },    //256MB
	{0x71,  256 },    //256MB
	{0xDC,  512 },    //512MB
	{0xD3,  1024},    //1GB
	{0xD5,  2048},    //2GB
	{0xFF,  0xffff}
}; 

DWORD Nand_Id_Calculate(DWORD id)
{
	DWORD pagesize;
	DWORD blksize;
//	DWORD dwtmpval;
	WORD  maker_id,size_id,id_4th;
	WORD  i;
	WORD  temp;
	DWORD dwTotalSize_KB;

//	NandRomFlag = 0;

	maker_id = (WORD)id&0xff;
	size_id  = (WORD)(id>>8)&0xff;	
	id_4th   = (WORD)(id>>24)&0xff;
	
	/* Get Nand ID table */
	for (i = 0; NAND_ID_Table[i][0] != 0xFF; i++)
	{
		temp = i+1;
		if (NAND_ID_Table[i][0] == size_id)
		{
			temp = i;
			dwTotalSize_KB = (DWORD)(NAND_ID_Table[i][1])<<10;
			break;
		}
	}

	if (NAND_ID_Table[temp][0] == 0xFF)
	{
		return -1;
	}

//	if((NAND_ID_Table[temp][1] <= 128)&&(size_id != 0xF1))
	if(NAND_ID_Table[temp][1] < 128)		//wwj modify
	{
		NAND_PAGE_SIZE      	= 512;
		NAND_PAGE_SPARE_SIZE 	= 16;
		NAND_BLOCK_PAGE_SIZE    = 32;
	}
	else
	{
		pagesize = id_4th&0x03;
		blksize  = (id_4th&0x30)>>4;
		
		switch (pagesize)
		{
			case 0x00:
				NAND_PAGE_SIZE			= 512;			
				NAND_PAGE_SPARE_SIZE	= 16;
				break;

			case 0x01:
				NAND_PAGE_SIZE			= 2048;			
				NAND_PAGE_SPARE_SIZE	= 64;
				break;

			case 0x02:
				NAND_PAGE_SIZE			= 4096;			
				NAND_PAGE_SPARE_SIZE	= 128;
				break;

			case 0x03:
				NAND_PAGE_SIZE			= 8192;			
				NAND_PAGE_SPARE_SIZE	= 256;
				break;

			default: 
				NAND_PAGE_SIZE			= 0xFFFF;
				NAND_PAGE_SPARE_SIZE	= 0xFFFF;
				break;
		}

		switch (blksize)
		{
			case 0x00:
//				blksize = 65536;
				blksize = 16384;		//wwj modify, 2010/3/26
				NAND_BLOCK_PAGE_SIZE  = blksize/NAND_PAGE_SIZE;
				break;

			case 0x01:
				blksize = 131072;
				NAND_BLOCK_PAGE_SIZE  = blksize/NAND_PAGE_SIZE;
				break;

			case 0x02:
				blksize = 262144;
				NAND_BLOCK_PAGE_SIZE  = blksize/NAND_PAGE_SIZE;
				break;

			case 0x03:
				blksize = 524288;
				NAND_BLOCK_PAGE_SIZE  = blksize/NAND_PAGE_SIZE;
				break;

			default:
				NAND_BLOCK_PAGE_SIZE  = 0xFFFF;
				break;
		}
	}

	switch(NAND_BLOCK_PAGE_SIZE)
	{
		case 128:
			NAND_TYPE 					= NAND_MLC;
			NAND_BANK_SIZE				= 512;
			NAND_BANK_RECYCLE_SIZE		= 64;
			break;

		case 64:
			if(NAND_PAGE_SIZE == 512)
			{
				NAND_TYPE 				= NAND_SLC_SMALL_BLK;
				NAND_BANK_SIZE			= 200;
				NAND_BANK_RECYCLE_SIZE  = 20;
			}
			else
			{
				NAND_TYPE 				= NAND_SLC_LARGE_BLK;
				NAND_BANK_SIZE			= 512;
				NAND_BANK_RECYCLE_SIZE  = 64;
			}
			break;

//---------------------------------------------------------------------------------------
//wwj add
		case 32:
			blksize = 16384;		//2009/5/11
			NAND_TYPE 				= NAND_SLC_SMALL_BLK;
			NAND_BANK_SIZE			= 200;
			NAND_BANK_RECYCLE_SIZE  = 20;
			break;
//---------------------------------------------------------------------------------------

		default :
			NAND_TYPE = 0xffff;
			break;
	}

	NAND_BLK_NUM = dwTotalSize_KB/(blksize>>10);
//	NAND_APP_AREA_START = 6;

//	if((*P_MCS2_Ctrl & 0x00c0) == 0x00c0) {

		NAND_APP_AREA_START 				= APP_AREA_START;
		NAND_APP_AREA_SIZE					= APP_AREA_SIZE;
		NAND_APP_AREA_SPARE_START			= (NAND_APP_AREA_START + NAND_APP_AREA_SIZE);
		NAND_APP_AREA_SPARE_SIZE			= APP_AREA_SPARE_SIZE;
		//-----------------------------------------------------------------------
		//2009/5/11 wwj add
		if(NAND_APP_AREA_SPARE_SIZE > NAND_PAGE_SIZE/4) {
			NAND_APP_AREA_SPARE_SIZE = NAND_PAGE_SIZE/4;
		}
		//-----------------------------------------------------------------------

		NAND_DATA_AREA_START				= (NAND_APP_AREA_SPARE_START + NAND_APP_AREA_SPARE_SIZE);

//	} else {
//
//		NAND_APP_AREA_START 				= 1;
//		NAND_APP_AREA_SIZE					= (NAND_BLK_NUM * 24ul)/25;
//		NAND_APP_AREA_SPARE_START			= (NAND_APP_AREA_START + NAND_APP_AREA_SIZE);
//		NAND_APP_AREA_SPARE_SIZE			= (NAND_BLK_NUM - NAND_APP_AREA_SPARE_START);
//		//-----------------------------------------------------------------------
//		//2009/5/11 wwj add
//		if(NAND_APP_AREA_SPARE_SIZE > NAND_PAGE_SIZE/4) {
//			NAND_APP_AREA_SPARE_SIZE = NAND_PAGE_SIZE/4;
//		}
//		//-----------------------------------------------------------------------
//
//		NAND_DATA_AREA_START				= (NAND_APP_AREA_SPARE_START + NAND_APP_AREA_SPARE_SIZE);
//
//	}

	NAND_BANK_NUM = (NAND_BLK_NUM - NAND_DATA_AREA_START + NAND_BANK_SIZE + NAND_BANK_RECYCLE_SIZE -1)/(NAND_BANK_SIZE+NAND_BANK_RECYCLE_SIZE);

#ifndef NAND_DRIVER_SPEEDUP
	NAND_MM_NUM	= 1;
#else
	NAND_MM_NUM	= NAND_BANK_NUM;
#endif

	return 0;
}


/*=============================================================
			Driver Get Nand Flash Spec Functions
=============================================================*/
//void GetNandInfo(NF_USER_INFO *user_info)
INT GetNandInfo(void)		//wwj modify
{	
	DWORD wNandID;

	Get_Nand_Settings();		//wwj add

	NAND_ReadID(&wNandID);
	NandRomFlag = 0;
	if((wNandID&0xffff) == 0x58c2) { //Generalplus NAND ROM
		NandRomFlag = 1;
		return 0;
	} else if(((wNandID&0xffff) == 0x5ac2) || ((wNandID&0xffff) == 0x76c2) || ((wNandID&0xffff) == 0x79c2)) { //Generalplus NAND ROM
		NandRomFlag = 2;
		return 0;
	} else if(((wNandID&0xffff) == 0x7398) || ((wNandID&0xffff) == 0x7598)) { //SanDisk NAND OTP
		NandRomFlag = 1;		//three address cycle
		return 0;
	} else if(((wNandID&0xffff) == 0x7698) || ((wNandID&0xffff) == 0x7998)) { //SanDisk NAND OTP
		NandRomFlag = 2;		//four address cycle
		return 0;
	}

	if(Nand_Id_Calculate(wNandID)) {
		return NF_UNKNOW_TYPE;
	}

	NAND_CHIP_ID						= wNandID;

	NAND_BOOT_AREA_WRITE_ATTR			= BOOT_AREA_WRITE_ATTR;
	NAND_APP_AREA_WRITE_ATTR			= APP_AREA_WRITE_ATTR;

	NAND_DIRECT_READ					= DIRECT_READ;

	return  0;

}

/*=============================================================
				Driver	OS  Functions
=============================================================*/
#ifndef NAND_NO_OS
 #include ".\system\include\minios\unOS.h" 
 OS_EVENT * gNAND_sem=NULL;
 OS_EVENT * gNAND_PHY_sem =NULL;
#endif	

int  NAND_OS_Init (void) 
{
	#ifndef NAND_NO_OS	
	if(NULL == gNAND_sem)
	{
    	gNAND_sem = unOSSemCreate(1);	
	}
	#endif   
    return (0);
}

void NAND_OS_LOCK(void)
{
	#ifndef NAND_NO_OS	
		unsigned char err = NULL;	
		unOSSemPend(gNAND_sem , 0 , &err);
	#endif	
}

void NAND_OS_UNLOCK(void)
{
	#ifndef NAND_NO_OS	
		unOSSemPost(gNAND_sem);
	#endif	
}

int  NAND_OS_Exit (void) 
{
    return (0);
}

int  NAND_OS_PHY_Init (void) 
{
#ifdef NAND_DRIVER_DIRECT_READ_SUPPORT	
	#ifndef NAND_NO_OS		
	if(NULL == gNAND_PHY_sem)
	{
    	gNAND_PHY_sem = unOSSemCreate(1);	
	}
	#endif
#endif	
    return (0);
}

void NAND_OS_PHY_LOCK(void)
{
#ifdef NAND_DRIVER_DIRECT_READ_SUPPORT	
	#ifndef NAND_NO_OS	
		unsigned char err = NULL;	
		unOSSemPend(gNAND_PHY_sem , 0 , &err);
	#endif	
#endif	
}

void NAND_OS_PHY_UNLOCK(void)
{
#ifdef NAND_DRIVER_DIRECT_READ_SUPPORT	
	#ifndef NAND_NO_OS	
		unOSSemPost(gNAND_PHY_sem);
	#endif
#endif	
}

int  NAND_OS_PHY_Exit (void) 
{
    return (0);
}

//-------------------------------------------------------------------------------------
//Functions added by WWJ
//-------------------------------------------------------------------------------------
void Nand_Write_Enable(void)
{
	
}

void Nand_Write_Disable(void)
{
	
	
}

void Get_Nand_Settings(void)
{
	R_NF_Ctrl = 0x0055;
	R_Burst_Read = 0x0000;
	R_Burst_Write = 0x0000;

	R_BootLoader_Sectors = C_LOADER1_SECTORS + C_LOADER2_SECTORS;	//2009/10/26
}