#ifndef _NAND_CONFIG_H_
 #define _NAND_CONFIG_H_
 #include "Nand\NandDef.h"

/*######################################################
#												 		#
#	   Nand Flash Driver OS/NO_OS Configuration 		#
#														#
 #####################################################*/
#define NAND_NO_OS


/*######################################################
#												 		#
#	   Nand Flash Driver Speed Up Configuration			#
#														#
 ######################################################*/
//#define NAND_DRIVER_SPEEDUP	// Use additional ram to speed up read/write


/*######################################################
#												 		#
#	Nand Flash Driver Direct Read Configuration			#
#														#
 ######################################################*/
//#define NAND_DRIVER_DIRECT_READ_SUPPORT


/*######################################################
#												 		#
#	Nand Flash Driver BOOT Area Write Configuration		#
#														#
 ######################################################*/
#define NAND_DRIVER_BOOT_AREA_WRITE_ENABLE


/*######################################################
#												 		#
#	Nand Flash Driver APP Area Write Configuration		#
#														#
 ######################################################*/
#define NAND_DRIVER_APP_AREA_WRITE_ENABLE


//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//below configuration is for CS2 Nand Flash
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

/*######################################################
#												 		#
#	   Nand Flash Blocks Assignation Configuration		#
#														#
 ######################################################*/
#define APP_AREA_START				11			/* Start Physical Block Address */
#define APP_AREA_SIZE				40			/* APP Area Size|Block numbers. */
#define APP_AREA_SPARE_START		(APP_AREA_START + APP_AREA_SIZE)
#define	APP_AREA_SPARE_SIZE			(APP_AREA_SIZE/4)	/* Spare area size */
#define DATA_AREA_START				(APP_AREA_SPARE_START + APP_AREA_SPARE_SIZE)

/*######################################################
#												 		#
#	    Nand Flash Spec/Type Configuration	        	#
#														#
 ######################################################*/
//#define K9F1G08U0A
//#define K9G8G08U0M  //test GP6B
//#define HY27UT084G2A  //test GP4V06
//#define HY27UF081G2A  //test GP4V06
//#define MT29F2G08AAC
//#define K9F1208U0A
//#define HY27UT088G2M
//#define test_nand
#define SUPPORTALL

#if defined SUPPORTALL
	#define CHIP_ID		 	0xffffffff
	#define BLK_NUM		 	16384		// blocks per nand
	#define BLK_PAGE_NUM 	128			// pages  per block
	#define PAGE_SIZE	 	4096		// bytes  per page
	#define SPARE_SIZE	 	128
	#define	NF_TYPE			NAND_ALL
#elif defined HY27UT084G2A
	#define CHIP_ID		 			0xa514dcad
	#define BLK_NUM		 			2048		// blocks per nand
	#define BLK_PAGE_NUM 			128			// pages  per block
	#define PAGE_SIZE	 			2048		// bytes  per page
	#define SPARE_SIZE	 			64
	#define	NF_TYPE					NAND_MLC
#elif defined	test_nand
	#define CHIP_ID		 			0x2514d3ec
	#define BLK_NUM		 			4096		// blocks per nand
	#define BLK_PAGE_NUM 			128			// pages  per block
	#define PAGE_SIZE	 			4096		// bytes  per page
	#define SPARE_SIZE	 			128
	#define	NF_TYPE					NAND_MLC	
#elif defined	K9G8G08U0M
	#define CHIP_ID		 			0x2514d3ec
	#define BLK_NUM		 			4096		// blocks per nand
	#define BLK_PAGE_NUM 			128			// pages  per block
	#define PAGE_SIZE	 			2048		// bytes  per page
	#define SPARE_SIZE	 			64
	#define	NF_TYPE					NAND_MLC
#elif defined K9F1G08U0A
	#define CHIP_ID		 			0x1580f1ec
	#define BLK_NUM		 			1024		// blocks per nand
	#define BLK_PAGE_NUM 			64			// pages  per block
	#define PAGE_SIZE	 			2048		// bytes  per page
	#define SPARE_SIZE	 			64
	#define	NF_TYPE					NAND_SLC_LARGE_BLK
#elif defined	MT29F2G08AAC
	#define CHIP_ID		 			0x1580da2c
	#define BLK_NUM		 			2048		// blocks per nand
	#define BLK_PAGE_NUM 			64			// pages  per block
	#define PAGE_SIZE	 			2048		// bytes  per page
	#define SPARE_SIZE	 			64
	#define	NF_TYPE					NAND_SLC_LARGE_BLK
#elif defined	HY27UF081G2A
	#define CHIP_ID		 			0x1d80f1ad
	#define BLK_NUM		 			1024		// blocks per nand
	#define BLK_PAGE_NUM 			64			// pages  per block
	#define PAGE_SIZE	 			2048		// bytes  per page
	#define SPARE_SIZE	 			64
	#define	NF_TYPE					NAND_SLC_LARGE_BLK
#elif defined	K9K8G08U0M
	#define CHIP_ID		 			0xa514dcad
	#define BLK_NUM		 			8192		// blocks per nand
	#define BLK_PAGE_NUM 			64			// pages  per block
	#define PAGE_SIZE	 			2048		// bytes  per page
	#define SPARE_SIZE	 			64
	#define	NF_TYPE					NAND_SLC_LARGE_BLK
#elif defined	HY27UT088G2A
	#define CHIP_ID		 			0xa514d3ad
	#define BLK_NUM		 			4096		// blocks per nand
	#define BLK_PAGE_NUM 			128			// pages  per block
	#define PAGE_SIZE	 			2048		// bytes  per page
	#define SPARE_SIZE	 			64
	#define	NF_TYPE					NAND_MLC
#elif defined 	HY27US08121A
	#define CHIP_ID		 			0xa514d3ad
	#define BLK_NUM		 			4096		// blocks per nand
	#define BLK_PAGE_NUM 			32			// pages  per block
	#define PAGE_SIZE	 			512			// bytes  per page
	#define SPARE_SIZE	 			16
	#define	NF_TYPE					NAND_SLC_SMALL_BLK
#elif defined 	K9F1208U0A
	#define CHIP_ID		 			0xc0a576ec
	#define BLK_NUM		 			4096		// blocks per nand
	#define BLK_PAGE_NUM 			32			// pages  per block
	#define PAGE_SIZE	 			512			// bytes  per page
	#define SPARE_SIZE	 			16
	#define	NF_TYPE					NAND_SLC_SMALL_BLK
#elif defined M29F2G08AA0
	#define CHIP_ID		 			0xd01580da
	#define BLK_NUM		 			2048		// blocks per nand
	#define BLK_PAGE_NUM 			128			// pages  per block
	#define PAGE_SIZE	 			2048		// bytes  per page
	#define SPARE_SIZE	 			64
	#define	NF_TYPE					NAND_SLC_LARGE_BLK
#elif defined HY27UT088G2M	
	#define CHIP_ID		 			0xa514d3ad
	#define BLK_NUM		 			4096		// blocks per nand
	#define BLK_PAGE_NUM 			128			// pages  per block
	#define PAGE_SIZE	 			2048		// bytes  per page
	#define SPARE_SIZE	 			64
	#define	NF_TYPE					NAND_SLC_LARGE_BLK
#else
	" Error: NandFlash Type Not Match!! "
#endif

/*######################################################
#												 		#
#	   Nand Flash Driver Bank&Recycle Configuration	    #
#														#
 ######################################################*/
#if NF_TYPE == NAND_SLC_SMALL_BLK//wwj add
	#define BANK_LOGIC_SIZE				200
	#define BANK_RECYCLE_SIZE 			20
#else
	#define BANK_LOGIC_SIZE				512
	#define BANK_RECYCLE_SIZE 			64
#endif

/*######################	Warning		############################
#																	#
#		Don`t modify the content below,otherwise it will			#
# 	be cause driver can`t work normally or can`t work optimumly!	#
#																	#
###################################################################*/
#define BANK_TOTAL_SIZE 			(BANK_LOGIC_SIZE + BANK_RECYCLE_SIZE)
#define BANK_NUM					((BLK_NUM - DATA_AREA_START + BANK_TOTAL_SIZE -1)/BANK_TOTAL_SIZE)

#ifndef NAND_DRIVER_SPEEDUP
	#define MM_NUM					1
#else
	#define MM_NUM					BANK_NUM
#endif

#ifdef NAND_DRIVER_BOOT_AREA_WRITE_ENABLE
	#define BOOT_AREA_WRITE_ATTR	WRITE_ENABLE
#else
	#define BOOT_AREA_WRITE_ATTR	WRITE_DISABLE
#endif

#ifdef NAND_DRIVER_APP_AREA_WRITE_ENABLE
	#define APP_AREA_WRITE_ATTR		WRITE_ENABLE
#else
	#define APP_AREA_WRITE_ATTR		WRITE_DISABLE
#endif

#ifndef NAND_DRIVER_DIRECT_READ_SUPPORT
	#define MP3_MM_TYPE				DWORD
	#define MP3_TT_TYPE				DWORD
	#define DIRECT_READ				DIRECT_READ_UNSUPPORT
#else
	#define MP3_MM_TYPE				MM
	#define MP3_TT_TYPE				TT
	#define DIRECT_READ				DIRECT_READ_SUPPORT
#endif

#define ExchangeAMaxNum				4

/* -------------------   Struct Type Define   ----------------- */
typedef struct
{
	DWORD	ulSelectID;
	WORD	uiNandType;
	WORD  	uiBlkNum;
	WORD  	uiPageNum;
	WORD  	uiPageSize;
	WORD	uiPageSpareSize;
	WORD	uiBankNum;
	WORD	uiBankSize;
	WORD	uiBankRecSize;
	WORD	uiMM_Num;

	WORD  	uiAppStart;
	WORD  	uiAppSize;
	WORD 	uiAppSpareStart;
	WORD 	uiAppSpareSize;
	WORD 	uiDataStart;

	WORD	uiBootAreaWriteAttr;
	WORD	uiAppAreaWriteAttr;

	WORD	uiDirReadSupport;
	WORD	ucWithEccEngine;	//kingchao add, 2015/06/09
}NF_USER_INFO;

typedef struct
{
	WORD	wRecycleBlkNum;
	WORD	wLogicBlkNum;
	WORD	wMapTableBlk;
	WORD	wMapTablePage;
}BANK_INFO;

typedef struct
{
	WORD	Logic2Physic[BANK_LOGIC_SIZE];
	WORD	RecycleBlk[BANK_RECYCLE_SIZE];
}IMM;

typedef union 
{
	IMM 	Maptable;
	WORD  	pMaptable[BANK_TOTAL_SIZE];
}MM;

typedef struct
{
	WORD wPageData[PAGE_SIZE>>BYTE2WORD];
	WORD wBad_Flag;
	WORD wLogicNum;
	WORD wCount;
	WORD wExchangeType;
	WORD wP2P;
}WB;

typedef union
{
	WB PageTag;
	WORD WorkBuffer[(PAGE_SIZE+SPARE_SIZE)>>BYTE2WORD];
}TT;

typedef struct
{
	WORD	wLogicBlk;
	WORD	wPhysicBlk;
}L2P;

typedef struct
{
	WORD	wBank;
	WORD	wLogicBlk;
	WORD	wPhysicBlk;
	WORD	wCurrentPage;
	WORD	wCount;
	WORD	wPage2PageTable[128];
}EXCHANGE_A_BLK;

typedef struct
{
	WORD	wBank;
	WORD	wLogicBlk;
	WORD	wPhysicBlk;
	WORD	wCurrentPage;
	WORD	wCurrentSector;
	WORD	wCount;
}EXCHANGE_B_BLK;

typedef struct
{
	WORD	wMapTableBlk;
	WORD	wMapTablePage;
}NAND_HEAD;

typedef struct
{
	WORD	wPhysicBlkNum;
	WORD	wLogicBlkNum;
}IBT;
#endif